from __future__ import print_function
import datetime
from pprint import pprint



#--------------------
# global variables
#--------------------
blank_space = " "
colon_mark = ":"

#------------------------
# Module =>  say_hello()
#------------------------
def hello():
	# z_print(f"Good evening!\tz_print will auto print nicely!", show_time=True)
	
	t = int(z_time(time_format="hour"))

	if t in range(0, 6):
		print("🔥 OMG！现在是清晨！您起得太早了吧？燃起来了^_^")
	elif t in range(6, 12):
		print("🌅 早上好，🍵咖啡+牛奶，开启美好一天！")
	elif t in range(12, 14):
		print("😎 要记得午休！中午不睡，下午瞌睡！记得保护眼睛！")
	elif t in range(14, 18):
		print("🎶 上班ing...")
	elif t in range(18, 19):
		print("🍕 下班！吃饭！")
	elif t in range(19, 23):
		print("🌙 晚上好！据说这个时间点可以培养一生的爱好！")
	elif t in range(23, 24):
		print("🌆 该睡觉了！关机！上床！晚安！")


#---------------------
# Module => time_str print
#---------------------
def z_time(time_format="time", time_symlink = ":"):

	"""
	- 时间参数：
		- time_format = "time" 	#　"time": hour,minute,second，可选"date"(year,month,day), "datetime"
		- time_symlink = ":"  	# 时间之间的连接符　hour:minute:second
	- test code:
		print("time:", z_time("time", ":"))
		print("date:", z_time("date", "-"))
		print("datetime:", z_time("datetime", "-"))

	"""
	import datetime

	assert time_format in ["time", "date", "datetime", "hour"], "time_format invalid!"
	fmt = ""

	if time_format == "time":
		fmt = time_symlink.join(["%H", "%M", "%S"])
	elif time_format == "date":
		# fmt = time_symlink.join(["%Y", "%m", "%d"])
		fmt = "%Y-%m-%d"
	elif time_format == "datetime":
		fmt = "%Y-%m-%d " + time_symlink.join(["%H", "%M", "%S"])
	elif time_format == "hour":
		fmt = "%H"


	return datetime.datetime.now().strftime(fmt)


# --------------------------------------------------------
# Module => Use z_print() to print to console and to file.
# --------------------------------------------------------
def out(*message, 
			to_console=True,			# 输出到console(default)

		    to_file=None, 				# 输出到file，两种类型，str和io_text.　１.str类型是传入地址，自动创建并且打开文件，需要指定文件的mode，即to_file_mode；2.IO_text类型，提前创建文件，直接传入open后的文件名
		    to_file_mode="a+",			#　to_file为地址时设定，默认为"w+"，如果是IO_text类型，不需要使用此参数。
		    
		    show_time=False,				# 是否显示时间
		    time_format="time",			#　可选　"time", "date", "datetime"
		    time_symlink = ":",			# 时间之间的连接符　hour:minute:second
		    
		    identifier = "(🍉 z_print)",	# 标识符, (z_print) 12:12:31 => message
		    msg_symlink=" ==> ",			# message之前的连接符号
		    pp_stream=None, pp_indent=1, pp_width=80, pp_depth=None, pp_compact=False, 		# pretty print config 


		    end="\n",					# 默认打印完换行
		    ):
	
	"""
	#-----------------
	#  	1.Quick Use
	#-----------------

	epoch, acc, loss = 77, 0.96712, 0.123
	
	==> 1.输出到file 
	# 方式１
	save_out = "test.log" 	# <class '_io.TextIOWrapper'>
	f = open(save_out, "a+")
	z_print(f"epoch: {epoch}  | accuracy: {acc:.2f}% | loss: {loss:.2f}%", to_file=f, to_console=False)
	f.close()
	
	# 方式２(recommanded)
	z_print(f"epoch: {epoch}  | accuracy: {acc:.2f}% | loss: {loss:.2f}%", to_file="training_info.txt", to_file_mode="a+", to_console=False)
	
	==> 2.输出到console
	z_print("123", show_time=True, time_format="time")



	#---------------
	# 	2.Finished
	#---------------
	- 1.自定义前缀,带有标识，(z_print) 12:12:31  -->  
	- 2.两种方式写入file:# 输出到file，两种类型，str和io_text.　
		- str类型是传入地址，自动创建并且打开文件，需要指定文件的mode，即to_file_mode;
		- IO_text类型，提前创建文件，直接传入open后的文件名;

		->	z_print(f"epoch: {epoch} | accuracy: {acc:.2f}% | loss: {loss:.2f}%", to_file="training_info.txt", to_file_mode="a+", to_console=True)
		->	z_print(f"epoch: {epoch} | accuracy: {acc:.2f}% | loss: {loss:.2f}%", show_time=True ,to_file="training_info.txt", to_file_mode="a+", to_console=False)	
		->	save_out = "test.log" 	# <class '_io.TextIOWrapper'>
		->	f = open(save_out, "a+")
		->	# z_print(f"epoch: {epoch}  | accuracy: {acc:.2f}% | loss: {loss:.2f}%", to_file=f, to_console=True, show_time=True)
		->	z_print(f"{epoch}\t{acc}\t{loss}\tcat", to_file=f, show_time=False, to_console=False)
		->	f.close()


	- 3. z_print() => 纳入pretty print,自动根据输入数据的类型进行调整，支持类型如下：
		->	z_print("111123", "hhhelo", dict_case) 							#  support for type print(a,b,c) 
		->	z_print(f"dictionay is:", "123213", dict_case, "----------") 	#  support for type print(a,b,c) 
		->	z_print(dict_case, f"dictionay is:", "123213", "----------") 	#  support for type print(a,b,c) 
		->	z_print(f"dictionay is:", array_case, "----------") 			#  support for type print(a,b,c)
		->	z_print(dict_case, pp_indent=2, show_time=True) 				#  pretty print
		->	z_print("epoch:{}, acc:{:.2f}, loss:{:.2f}".format(66, 0.94823, 0.1234), show_time=True, time_format="date") 	# support for format-string
		->	z_print(f"epoch: {epoch}  | accuracy: {acc:.2f}% | loss: {loss:.2f}%", show_time=True) 	 						# support for f-string
	- 4.z_time() => 根据fomat返回时间字符串，目前支持 "年月日 时分秒"
	- 5.hello() => 问候函数


	#---------------
	# 	3.To do
	#---------------
	- z_time() 提供对 week 的支持。
	- 显示代码的文件名和函数
	- 配置函数config

	"""	


	#------------------------
	# 	global variables
	#------------------------
	global blank_space
	global colon_mark


	# at least one output
	assert to_console or to_file, "Error: you have to choose to output ot [file] or [console]"

	#------------------------
	# ===> Part 1. output to file
	#------------------------
	if to_file:

		# 1. string to be write into file
		content_2_file = ""

		# 2. show time or not  (optional)
		if show_time:	
			content_2_file	+= f"{z_time(time_format, time_symlink)}{msg_symlink}"
		
		# 3. concat message
		content_2_file += f"{message[0]}" 	# unwrap tuple, or pick the first item

		# 4. check the file input is "str" or "IO_Text" 
		if isinstance(to_file, str):	# str -> open then print
			f = open(to_file, to_file_mode)
			print(f"{content_2_file}", end=end, file=f)
			f.close()
		else:	# IO_Text -> print directly 
			print(f"{content_2_file}", end=end, file=to_file)

		
	#---------------------------------------------------------------------
	# ===> Part 2. output to Console
	# case one : sigle item	 e.g. z_print(f"xxx")
	# case two : multi itemS	 e.g. z_print(f"xxx", x_1, x_2, "xxxx")
	# solution => [1. str -> print()  2.not str -> pprint()]
	#---------------------------------------------------------------------
	if to_console:

		# 1.prefix (fixed but can modified)
		content_2_console = f"{identifier}"

		# 2.show time or not (optional)
		if show_time:
			content_2_console += f"{blank_space}{z_time(time_format, time_symlink)}"

		# 3.msg symlink (fixed)
		content_2_console += f"{msg_symlink}"

		# 4.print first
		print(content_2_console, end="") 	# To here, it should be like this: (🍉 z_print) 21:44:56 ==> 
		
		# 5.multi itemS in message
		if len(message) != 1:
			print("")	# /n first
			for idx, item in enumerate(message):
				if isinstance(item, str):	# string item -> print()
					if idx != len(message)-1:	# not last item ? then  not \n, but 2 spaces between string item
						print(item, end=blank_space*2) 
					else:
						print(item) 	# \n, last item
				else:	# not string, e.g. list or dict -> pprint()
					if idx != 0:
						print("") 	# \n first
					pprint(item, stream=pp_stream, indent=pp_indent, width=pp_width, depth=pp_depth, compact=pp_compact)    # \n 
		# 6.only one item in message
		else:
			# string item -> print()
			if isinstance(*message, str):
				print(*message)
			# [dict or list] item -> pprint() 	
			else:
				print("")
				pprint(*message, stream=pp_stream, indent=pp_indent, width=pp_width, depth=pp_depth, compact=pp_compact)
		


if __name__ == '__main__':

	hello()
	
	# epoch, acc, loss = 77, 0.96712, 0.123
	# import numpy as np
	# array_case = np.random.randn(4,4)
	# dict_case = {
	# 	"a": 123,
	# 	"b": {"123": 123, "456": 456},
	# 	"c": ["777", "Beijing", 1, 2, 3, 4, 5, 6, 7, 8, 9],
	# 	"d": 456,
	# 	"e": 999
	# }
	
	# ------------------------------------
	# 1. use case to test Console output
	# ------------------------------------
	# z_print(f"Good evening!\tz_print will auto print nicely!", show_time=True)
	# z_print(dict_case, pp_indent=2, show_time=True) # prety print
	# z_print("epoch:{}, acc:{:.2f}, loss:{:.2f}".format(66, 0.94823, 0.1234), show_time=True, time_format="date") 	# # support for format-string
	# z_print(f"epoch: {epoch}  | accuracy: {acc:.2f}% | loss: {loss:.2f}%", show_time=True) 	 	# support for f-string
	# z_print("111123", "hhhelo", dict_case) 	#  support for type print(a,b,c) 
	# z_print(f"dictionay is:", "123213", dict_case, "----------") 	#  support for type print(a,b,c) 
	# z_print(dict_case, f"dictionay is:", "123213", "----------") 	#  support for type print(a,b,c) 
	# z_print(f"dictionay is:", array_case, "----------") 	#  support for type print(a,b,c) 
	# z_print("epoch:{}, acc:{}, loss:{}".format(epoch, acc, loss))

	# ------------------------------------
	# 2. use case to test File output
	# ------------------------------------	
	# z_print(f"epoch: {epoch} | accuracy: {acc:.2f}% | loss: {loss:.2f}%", to_file="training_info.txt", to_file_mode="a+", to_console=True)
	# z_print(f"epoch: {epoch} | accuracy: {acc:.2f}% | loss: {loss:.2f}%", show_time=True ,to_file="training_info.txt", to_file_mode="a+", to_console=False)
	# save_out = "test.log" 	# <class '_io.TextIOWrapper'>
	# f = open(save_out, "a+")
	# # z_print(f"epoch: {epoch}  | accuracy: {acc:.2f}% | loss: {loss:.2f}%", to_file=f, to_console=True, show_time=True)
	# z_print(f"{epoch}\t{acc}\t{loss}\tcat", to_file=f, show_time=False, to_console=False)
	# f.close()

